package tests

import (
    "testing"
    "github.com/stretchr/testify/assert"
    browser "github.com/chromedp/chromedp"
)

func TestLogin(t *testing.T) {
    assert := assert.New(t)

    ctx, cancel := Setup(5); defer cancel()

    Run(assert, ctx,
      browser.Navigate(`http://127.0.0.1:5002/login/`),
      browser.WaitVisible(`body > footer`),
      browser.WaitVisible(`[data-testid="login-page"]`),
      browser.SendKeys(`#username`, `zedshaw`),
      browser.SendKeys(`#password`, `1234`),
      browser.Click(`#login-submit`, browser.NodeVisible),
      browser.WaitVisible(`body > footer`),
      browser.WaitVisible(`[data-testid="home-page"]`))
}

func TestStreamPage(t *testing.T) {
    assert := assert.New(t)

    ctx, cancel := Setup(2);
    defer cancel();

    var title string

    err := browser.Run(ctx,
      browser.Navigate(`http://127.0.0.1:5002`),
      browser.WaitVisible(`body > footer`),
      browser.WaitVisible(`#streams`),
    )
    assert.NoError(err)

	ClickOn(assert, ctx, `#streams`)

    err = browser.Run(ctx, browser.WaitVisible(`#streams-title`))
    assert.NoError(err)

    err = browser.Run(ctx, browser.Text(`#streams-title`, &title))
    assert.NoError(err)

    assert.Equal(title, "Past Streams")
}
